/*
    rate  --  statistic traffic analyzer
    Copyright (C) 2003 Mateusz 'mteg' Golicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct ipclassinfo
{
    struct ipclassinfo * next;
    u_int32_t net;
    u_int32_t mask;
};
	    
#define BAC_BYTES_OVERALL_IN	0
#define BAC_BYTES_OVERALL_OUT 	1
#define BAC_BYTES_MOMENTARY_IN	2
#define BAC_BYTES_MOMENTARY_OUT 3
#define BAC_PKT_OVERALL_IN		4
#define BAC_PKT_OVERALL_OUT		5
#define BAC_PKT_MOMENTARY_IN	6
#define BAC_PKT_MOMENTARY_OUT	7

/*
    bbb
	|||
	||+--- in / out
	|+---- overall / momentary 
    +----- bytes / packets
*/

struct entry
{
	struct entry * next;
	u_int32_t ip;
	long long counters[8];
};

struct top
{
	int n;
	struct entry ** top;
};

struct entry * get_entry(u_int32_t ip);
void add_entry(u_int32_t ip, long long in, long long out);
void zero_entries(void);

int is_ours(struct ipclassinfo * ci, u_int32_t host);
struct ipclassinfo * add_class(char * name, struct ipclassinfo * ci);
struct top * findtop(int n, int counter);
struct entry * get_hostlist(void);

