/*
    rate  --  statistic traffic analyzer
    Copyright (C) 2003 Mateusz 'mteg' Golicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef HAVE_REGEX
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef OPEN_BSD
#include <netinet/in_systm.h>
#endif
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <sys/timeb.h>
#include <signal.h>
#include <time.h>
#include <pcap.h>
#include "lib.h"
#ifdef HAVE_REGEX
#include <regex.h>
#endif
#include "iphash.h"
#include "protos.h"

extern int opt_caplen;
extern char opt_nul_char;

static char * opt_extractor = NULL;
static char * opt_order = NULL;
static int opt_ips = 0;

static void output(struct timeb * now, int miliFromStart, int miliFromLast, 
					unsigned long long totalbytes, unsigned long long totalpackets,
					unsigned long nowbytes, unsigned long nowpackets)
{
}



static void counter(const unsigned char * data, int caplen, int len)
{
	extractor(data, caplen, opt_nul_char, opt_ips);
}

static void help2(void)
{
	printf("\n\nREGEX EXTRACTOR USAGE: ... -E [-o output pattern] [-i] [-e] <pattern>\n");
	printf("  -i     Show packet source/destination IPs.\n");
	printf("  -e <r> Extract this pattern from packets.\n");
	printf("  -o <s> Output pattern.\n");
}

void r_extractor_setup(int argc, char ** argv,
						void (**custom_output)(struct timeb*, int, int, unsigned long long,
							  unsigned long long, unsigned long, unsigned long),
						void (**custom_counter)(const unsigned char *, int, int))
{
	int c;
	
	*custom_output = output;
	*custom_counter = counter;
	while((c = getopt(argc, argv, "?ho:e:i")) != EOF)
	{
		switch(c)
		{
			case '?':
			case 'h':
				help(argv[0]);
				help2();
				exit(0);
			case 'o':
				opt_order = strdup(optarg);
				break;
			case 'e':
				opt_extractor = strdup(optarg);
				break;
			case 'i':
				opt_ips = 1;
				break;
		}
	}

	if(argv[optind])
	{
		if(opt_extractor)
		{
			fprintf(stderr, "Extracting expression already specified: '%s' and '%s'...\n", opt_extractor, argv[optind]);
			exit(1);
		}
		else
			opt_extractor = argv[optind++];
	}


	if(!opt_extractor)
	{
		fprintf(stderr, "-e option was not specified. It is REQUIRED in this mode. Consult %s -E -h\n", argv[0]);
		exit(1);
	}

	if(opt_caplen < 1500) opt_caplen = 1500;
	prepare_extractor(opt_extractor, opt_order, opt_caplen);
}
#endif
